var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import ConfigProvider from '../config-provider';
import PropTypes from 'prop-types';
import React, { Component } from 'react';
import cls from 'classnames';
import hoistNonReactStatics from 'hoist-non-react-statics';
import { NumberPicker as NextNumberPicker } from '@alifd/next';
import { getTheme } from '../utils/getTheme';
class NumberPicker extends Component {
    constructor() {
        super(...arguments);
        this.onFocus = e => {
            const { onFocus, prefix = 'next-' } = this.props;
            const dom = e.target;
            dom.parentNode.parentElement.classList.add(`${prefix}input-group-focus`);
            onFocus && onFocus(e);
        };
        this.onBlur = e => {
            const { onBlur, prefix = 'next-' } = this.props;
            const dom = e.target;
            dom.parentNode.parentElement.classList.remove(`${prefix}input-group-focus`);
            onBlur && onBlur(e);
        };
    }
    render() {
        const { type } = this.props;
        const _a = this.props, { prefix = 'next-', className } = _a, otherProps = __rest(_a, ["prefix", "className"]);
        // const state = this.props.state ? this.props.state : '';
        const { state } = this.props;
        const theme = getTheme(this.context, this.props);
        // inline 模式
        if (type === 'inline' && state === 'error') {
            return (React.createElement(NextNumberPicker, Object.assign({}, otherProps, { onFocus: this.onFocus, onBlur: this.onBlur, prefix: prefix, className: cls(className, {
                    [`${prefix}number-picker-error`]: true,
                    [`${prefix}white`]: theme === 'white',
                    [`${prefix}grey`]: theme === 'grey',
                }) })));
        }
        return (React.createElement(NextNumberPicker, Object.assign({}, otherProps, { onFocus: this.onFocus, onBlur: this.onBlur, prefix: prefix, className: cls(className, {
                [`${prefix}white`]: theme === 'white',
                [`${prefix}grey`]: theme === 'grey',
            }) })));
    }
}
// contextTypes
NumberPicker.contextTypes = {
    theme: PropTypes.string,
};
hoistNonReactStatics(NumberPicker, NextNumberPicker);
export default ConfigProvider.config(NumberPicker);
